// WARNING: generated by kopium - manual changes will be overwritten
// kopium command: kopium -f databases.yml --schema=derived --docs -b --derive=Default --derive=PartialEq --smart-derive-elision
// kopium version: 0.21.1

#[allow(unused_imports)]
mod prelude {
    pub use kube_derive::CustomResource;
    #[cfg(feature = "schemars")]
    pub use schemars::JsonSchema;
    pub use serde::{Deserialize, Serialize};
    #[cfg(feature = "builder")]
    pub use typed_builder::TypedBuilder;
}
use self::prelude::*;

/// Specification of the desired Database.
/// More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
#[derive(CustomResource, Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
#[cfg_attr(not(feature = "schemars"), kube(schema = "disabled"))]
#[kube(
    group = "postgresql.cnpg.io",
    version = "v1",
    kind = "Database",
    plural = "databases"
)]
#[kube(namespaced)]
#[kube(status = "DatabaseStatus")]
#[kube(derive = "Default")]
#[kube(derive = "PartialEq")]
pub struct DatabaseSpec {
    /// Maps to the `ALLOW_CONNECTIONS` parameter of `CREATE DATABASE` and
    /// `ALTER DATABASE`. If false then no one can connect to this database.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "allowConnections"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub allow_connections: Option<bool>,
    /// Maps to the `BUILTIN_LOCALE` parameter of `CREATE DATABASE`. This
    /// setting cannot be changed. Specifies the locale name when the
    /// builtin provider is used. This option requires `localeProvider` to
    /// be set to `builtin`. Available from PostgreSQL 17.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "builtinLocale"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub builtin_locale: Option<String>,
    /// The name of the PostgreSQL cluster hosting the database.
    pub cluster: DatabaseCluster,
    /// Maps to the `COLLATION_VERSION` parameter of `CREATE DATABASE`. This
    /// setting cannot be changed.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "collationVersion"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub collation_version: Option<String>,
    /// Maps to the `CONNECTION LIMIT` clause of `CREATE DATABASE` and
    /// `ALTER DATABASE`. How many concurrent connections can be made to
    /// this database. -1 (the default) means no limit.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "connectionLimit"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub connection_limit: Option<i64>,
    /// The policy for end-of-life maintenance of this database.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "databaseReclaimPolicy"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub database_reclaim_policy: Option<DatabaseDatabaseReclaimPolicy>,
    /// Maps to the `ENCODING` parameter of `CREATE DATABASE`. This setting
    /// cannot be changed. Character set encoding to use in the database.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub encoding: Option<String>,
    /// Ensure the PostgreSQL database is `present` or `absent` - defaults to "present".
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub ensure: Option<DatabaseEnsure>,
    /// Maps to the `ICU_LOCALE` parameter of `CREATE DATABASE`. This
    /// setting cannot be changed. Specifies the ICU locale when the ICU
    /// provider is used. This option requires `localeProvider` to be set to
    /// `icu`. Available from PostgreSQL 15.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "icuLocale")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub icu_locale: Option<String>,
    /// Maps to the `ICU_RULES` parameter of `CREATE DATABASE`. This setting
    /// cannot be changed. Specifies additional collation rules to customize
    /// the behavior of the default collation. This option requires
    /// `localeProvider` to be set to `icu`. Available from PostgreSQL 16.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "icuRules")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub icu_rules: Option<String>,
    /// Maps to the `IS_TEMPLATE` parameter of `CREATE DATABASE` and `ALTER
    /// DATABASE`. If true, this database is considered a template and can
    /// be cloned by any user with `CREATEDB` privileges.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "isTemplate"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub is_template: Option<bool>,
    /// Maps to the `LOCALE` parameter of `CREATE DATABASE`. This setting
    /// cannot be changed. Sets the default collation order and character
    /// classification in the new database.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub locale: Option<String>,
    /// Maps to the `LC_CTYPE` parameter of `CREATE DATABASE`. This setting
    /// cannot be changed.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "localeCType"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub locale_c_type: Option<String>,
    /// Maps to the `LC_COLLATE` parameter of `CREATE DATABASE`. This
    /// setting cannot be changed.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "localeCollate"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub locale_collate: Option<String>,
    /// Maps to the `LOCALE_PROVIDER` parameter of `CREATE DATABASE`. This
    /// setting cannot be changed. This option sets the locale provider for
    /// databases created in the new cluster. Available from PostgreSQL 16.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "localeProvider"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub locale_provider: Option<String>,
    /// The name of the database to create inside PostgreSQL. This setting cannot be changed.
    pub name: String,
    /// Maps to the `OWNER` parameter of `CREATE DATABASE`.
    /// Maps to the `OWNER TO` command of `ALTER DATABASE`.
    /// The role name of the user who owns the database inside PostgreSQL.
    pub owner: String,
    /// Maps to the `TABLESPACE` parameter of `CREATE DATABASE`.
    /// Maps to the `SET TABLESPACE` command of `ALTER DATABASE`.
    /// The name of the tablespace (in PostgreSQL) that will be associated
    /// with the new database. This tablespace will be the default
    /// tablespace used for objects created in this database.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub tablespace: Option<String>,
    /// Maps to the `TEMPLATE` parameter of `CREATE DATABASE`. This setting
    /// cannot be changed. The name of the template from which to create
    /// this database.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub template: Option<String>,
}

/// The name of the PostgreSQL cluster hosting the database.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct DatabaseCluster {
    /// Name of the referent.
    /// This field is effectively required, but due to backwards compatibility is
    /// allowed to be empty. Instances of this type with an empty value here are
    /// almost certainly wrong.
    /// More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub name: Option<String>,
}

/// Specification of the desired Database.
/// More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
#[derive(Serialize, Deserialize, Clone, Debug, PartialEq)]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub enum DatabaseDatabaseReclaimPolicy {
    #[serde(rename = "delete")]
    Delete,
    #[serde(rename = "retain")]
    Retain,
}

/// Specification of the desired Database.
/// More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
#[derive(Serialize, Deserialize, Clone, Debug, PartialEq)]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub enum DatabaseEnsure {
    #[serde(rename = "present")]
    Present,
    #[serde(rename = "absent")]
    Absent,
}

/// Most recently observed status of the Database. This data may not be up to
/// date. Populated by the system. Read-only.
/// More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct DatabaseStatus {
    /// Applied is true if the database was reconciled correctly
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub applied: Option<bool>,
    /// Message is the reconciliation output message
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub message: Option<String>,
    /// A sequence number representing the latest
    /// desired state that was synchronized
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "observedGeneration"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub observed_generation: Option<i64>,
}
